# TAG Guidelines for creating web platform compatible components

The table below is to document the extent of which the MapML polyfill
conforms to the W3C <abbr title="Technical Architecture Group">TAG</abbr>'s
[Guidelines for creating web platform compatible components](https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/).

<table>
  <tr>
    <th scope="col">TAG Guideline</th>
    <th scope="col">Conforms</th>
    <th scope="col">Note</th>
  </tr>
  <tr>
    <th colspan="3" align="left">
      1.1 Native HTML elements
    </th>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Elements%20don%E2%80%99t%20throw%20errors%20when%20used%20declaratively">
      1. Elements don’t throw errors when used declaratively
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
    <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Elements%20are%20self-contained">
    2. Elements are self-contained
    </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Use%20events%20to%20pass%20data%20to%20the%20outside%20world">
      3. Use events to pass data to the outside world
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Use%20attributes%20to%20receive%20non-complex%20data">
      4. Use attributes to receive non-complex data
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Interactive%20elements%20are%20focusable">
      5. Interactive elements are focusable
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Elements%20can%20be%20instantiated%20without%20being%20part%20of%20the%20document">
      6. Elements can be instantiated without being part of the document
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Elements%20should%20only%20have%20basic%20styling">
      7. Elements should only have basic styling
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      See the
      <a href="https://github.com/Maps4HTML/Web-Map-Custom-Element/issues?q=label%3A%22basic+styling%22">basic styling</a>
      label for relevant issues/PRs
    </td>
  </tr>
  <tr>
    <th colspan="3" align="left">
      1.2 Other considerations
    </th>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Don%E2%80%99t%20enforce%20unnecessary%20child/parent%20relationships">
      1. Don’t enforce unnecessary child/parent relationships
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Avoid%20using%20callbacks">
      2. Avoid using callbacks
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
  <tr>
    <th scope="row" align="left">
      <a href="https://www.w3.org/2001/tag/doc/webcomponents-design-guidelines/#:~:text=Harmonize%20declarative%20(HTML)%20and%20imperative%20(JavaScript)%20APIs">
      3. Harmonize declarative (HTML) and imperative (JavaScript) APIs
      </a>
    </th>
    <td align="center">
      <ul><li>- [ ] </li></ul>
    </td>
    <td>
      TBD
    </td>
  </tr>
</table>
